<template>
    <section>
      <div class="row" v-if="loadingStatistic==false">
          <div class="col-sm-4 col-xl-4" v-for="stats in statsCards" :key="stats.title">
            <stats-card>
              <div class="icon-big text-center" :class="`${stats.type}`" slot="header">
                <i :class="stats.icon"></i>
              </div>
              <div class="numbers" slot="content">
                <p>{{stats.title}}</p>
                {{  stats.value.toLocaleString()}}
              </div>
              <div class="stats" slot="footer">
                <i :class="stats.footerIcon"></i> {{stats.footerText}}
              </div>
            </stats-card>
          </div>
        </div>
    <hr />
    <div class="row" v-if="loadingStatistic==false">
      <div class="col-md-12 col-lg-12">
        <div class="card">
            <div clas="card-body">
            <table class="table table-hover">
              <thead>
                <tr>
                    <th><a href="javascript:void(0);" @click="sortTable('thCountry')">ประเทศ / สถานที่<i class="fas " :class="[tableCovidColumnSortOrder=='desc' ?'fa-sort-alpha-down':'fa-sort-alpha-up']" v-if="tableCovidcolumnSearch=='thCountry'"></i></a></th>
                  
                    <th><a href="javascript:void(0);" @click="sortTable('confirmed')">ยอดผู้ติดเชื้อ<i class="fas " :class="[tableCovidColumnSortOrder=='desc' ?'fa-sort-alpha-down':'fa-sort-alpha-up']" v-if="tableCovidcolumnSearch=='confirmed'"></i></a></th>
                    <th><a href="javascript:void(0);" @click="sortTable('recovered')">ยอดผู้รักษาหาย<i class="fas " :class="[tableCovidColumnSortOrder=='desc' ?'fa-sort-alpha-down':'fa-sort-alpha-up']" v-if="tableCovidcolumnSearch=='recovered'"></i></a></th>
                    <th><a href="javascript:void(0);" @click="sortTable('dead')">ยอดผู้เสียชีวิต<i class="fas " :class="[tableCovidColumnSortOrder=='desc' ?'fa-sort-alpha-down':'fa-sort-alpha-up']" v-if="tableCovidcolumnSearch=='dead'"></i></a></th>
                  </tr>
              </thead>
              <tbody>
                <tr v-for="data in orderByProvinceTable">
                    <td>{{(data.thCountry==null || data.thCountry=="" ? data.location : data.thCountry)}}</td>
                    <td><strong>{{data.confirmed.toLocaleString()}}</strong></td>
                    <td><span class="text-success">{{data.recovered.toLocaleString()}}</span></td>
                      <td><span class="text-danger">{{data.dead.toLocaleString()}}</span></td>
                </tr>
              </tbody>
            </table>
            </div>
      </div>


        </div>
      </div>
      <div class="row" v-if="loadingStatistic==false">
          <h6>Source</h6>
          <div class="col-12">
          <ul>
              <li><a href="https://www.trackcorona.live" target="_blank">trackcorona.live</a></li>
          </ul>
          </div>
        </div>
      <div v-if="loadingStatistic">
        <div class="text-center">
 <div class="spinner-border" role="status">
                    <span class="sr-only">Loading...</span>
                  </div>
              </div>
      </div>
    </section>
    
</template>
<script>
import { StatsCard, ChartCard,PaperTable } from "@/components/index";
import axios from 'axios';
import Highcharts, { arrayMax } from 'highcharts';
import {Chart} from 'highcharts-vue';
import { BModal, VBModal } from 'bootstrap-vue'
export default {
  components: {
      StatsCard,
    ChartCard,
    PaperTable,
    highcharts : Chart,
    'b-modal':BModal
  },
  data(){
    return {
        statsCards:[],
        statsWorlds:{},
        tableStatistic:[],
        loadingStatistic:false,
        urlHost:"http://contents.i8app.net/",
       tableCovidColumnSortOrder:"desc",
       tableCovidcolumnSearch : "confirmed",
    }
  },
  computed:{
    orderByProvinceTable:function(){
      return _.orderBy(this.tableStatistic,this.tableCovidcolumnSearch,this.tableCovidColumnSortOrder)
    }
  },
  methods :{
    sortTable:function(columnName){
      if(columnName!= this.tableCovidcolumnSearch){
        this.tableCovidcolumnSearch= columnName
        this.tableCovidColumnSortOrder="desc"
      }
      else{
         this.tableCovidColumnSortOrder=(this.tableCovidColumnSortOrder=="asc" ? "desc":"asc")
      }

    },
    getCovidStatsWorld:function(){
          this.loadingStatistic=true
            let urlGet =this.urlHost+"/api/CovidtrackerAPI/GetCovidWorldStatistic"
            axios
              .get(urlGet)
              .then(response => {
                  this.loadingStatistic=false
                  if(response.status==200){
                    this.statsCards=[];
                    this.statsCards = [ {
                      type: "info",
                      icon: "fa fa-laptop-house text-info",
                      title: "ยอดผู้ติดเชื้อ",
                      value: response.data.confirmed,
                      footerText: "",
                      footerIcon : "fa fa-pen-alt"
                    }, {
                      type: "info",
                      icon: "fa fa-virus-slash text-success",
                      title: "ยอดผู้รักษาหาย",
                      value: response.data.recovered,
                      footerText: "",
                       footerIcon : "fa fa-pen-alt"
                    },{
                      type: "danger",
                      icon: "fa fa-hospital-user text-danger",
                      title: "ยอดผู้เสียชีวิต",
                      value: response.data.dealth,
                      footerText: "",
                       footerIcon : "fa fa-pen-alt"
                    }]
                    this.tableStatistic= response.data.countryStatistic
                  }
                
              })
              .catch(error => {
                 this.loadingStatistic=false
                  console.log(error)

              })
    }
  },
  mounted(){
    this.getCovidStatsWorld()
  }
};
</script>
<style>
</style>
